<?php

@%@BCWARNING=// @%@

/**
 * IMP Hooks configuration file.
 *
 * For more information please see the hooks.php.dist file.
 */

class IMP_Hooks
{
    /**
     * PREFERENCE INIT: Set preference values on login.
     *
     * See horde/config/hooks.php.dist for more information.
     */
    public function prefs_init($pref, $value, $username, $scope_ob)
    {
        switch ($pref) {
        case 'add_source':
            // Dynamically set the add_source preference.
            return is_null($username)
                ? $value
                : $GLOBALS['registry']->call('contacts/getDefaultShare');


        case 'search_fields':
        case 'search_sources':
            // Dynamically set the search_fields/search_sources preferences.
            if (!is_null($username)) {
                $sources = $GLOBALS['registry']->call('contacts/sources');

                if ($pref == 'search_fields') {
                    $out = array();
                    foreach (array_keys($sources) as $source) {
                        $out[$source] = array_keys($GLOBALS['registry']->call('contacts/fields', array($source)));
                    }
                } else {
                    $out = array_keys($sources);
                }

                return json_encode($out);
            }

            return $value;
        }
    }

    public function preauthenticate($userId, $credentials) {

        $userId = escapeshellcmd($userId);
        $ldaprdn  = $GLOBALS['conf']['ucs']['ldaprdn'];
        $ldappass = $GLOBALS['conf']['ucs']['ldappass'];
        $ldapbase = $GLOBALS['conf']['ucs']['ldapbase'];
        $ldaphost = $GLOBALS['conf']['ucs']['ldaphost'];
        $ldapport = $GLOBALS['conf']['ucs']['ldapport'];

        $euserId = ldap_escape($userId, null, LDAP_ESCAPE_FILTER);
        $ldapfilter = "(&(|(uid=$euserId)(mailprimaryaddress=$euserId))(objectclass=univentionmail))";
        $Id = "None";
        $ldapconn = ldap_connect("$ldaphost", $ldapport);
        ldap_set_option($ldapconn, LDAP_OPT_PROTOCOL_VERSION, 3);
        if ($ldapconn) {
            if (ldap_start_tls($ldapconn)) {
                $ldapbind = ldap_bind($ldapconn, $ldaprdn, $ldappass);
                if ($ldapbind) {
                    $r = ldap_search($ldapconn, $ldapbase, $ldapfilter, ['mailPrimaryAddress']);
                    $n = ldap_count_entries($ldapconn, $r);
                    if ($n == "1") {
                        $info = ldap_first_entry($ldapconn, $r);
                        $Id = ldap_get_values($ldapconn, $info, 'mailPrimaryAddress')[0];
                    }
                }
            }
        }

        return array(
            'userId' => $Id,
            'credentials' => $credentials,
        );
    }

}

